'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _hyperAws = require('hyper-aws4');

var _hyperAws2 = _interopRequireDefault(_hyperAws);

var _nodeFetch = require('node-fetch');

var _nodeFetch2 = _interopRequireDefault(_nodeFetch);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Hyper = function () {
  function Hyper(options) {
    _classCallCheck(this, Hyper);

    var _options = options || {};
    this.baseurl = 'https://us-west-1.hyper.sh';
    this.credential = Object.assign({}, {
      accessKey: process.env.HYPER_ACCESS,
      secretKey: process.env.HYPER_SECRET
    }, _options.credential || {});
  }

  _createClass(Hyper, [{
    key: 'sign',
    value: function sign(method, url, body) {
      var fullUrl = this.baseurl + url;
      var signOption = {
        method: method,
        credential: this.credential,
        url: fullUrl
      };
      if (body) signOption.body = JSON.stringify(body);
      var headers = _hyperAws2.default.sign(Object.assign({}, signOption));
      var fetchOptions = {
        fullUrl: fullUrl,
        method: signOption.method,
        headers: headers
      };
      if (body) fetchOptions.body = signOption.body;
      return fetchOptions;
    }
  }, {
    key: 'request',
    value: function request(method, url, body) {
      var fetchOptions = this.sign(method, url, body);
      return (0, _nodeFetch2.default)(fetchOptions.fullUrl, fetchOptions).then(function (res) {
        return res.text();
      });
    }
  }, {
    key: 'get',
    value: function get(url) {
      return this.request('GET', url);
    }
  }, {
    key: 'post',
    value: function post(url, body) {
      return this.request('POST', url, body);
    }
  }, {
    key: 'logs',
    value: function logs(containerId, callback) {}
  }]);

  return Hyper;
}();

exports.default = Hyper;
module.exports = exports['default'];